/*
 *  smb_fs_i.h
 *
 *  Copyright (C) 1995 by Paal-Kr. Engstad and Volker Lendecke
 *  Copyright (C) 1997 by Volker Lendecke
 *
 */

#ifndef _LINUX_SMB_FS_I
#define _LINUX_SMB_FS_I

#ifdef __KERNEL__
#include <linux/types.h>

/*
 * smb fs inode data (in memory only)
 */
struct smb_inode_info {

	/*
	 * file handles are local to a connection. A file is open if
	 * (open == generation).
	 */
        unsigned int open;
	__u16 fileid;		/* What id to handle a file with? */
	__u16 attr;		/* Attribute fields, DOS value */

	__u16 access;		/* Access bits. */
	__u16 cache_valid;	/* dircache valid? */
	unsigned long oldmtime;	/* last time refreshed */
	void * dentry;		/* The dentry we were opened with */
};

#endif
#endif
